DCMTK: DJCompressIJG16Bit Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Private Member Functions | Private Attributes | List of all members
DJCompressIJG16Bit Class Reference

this class encapsulates the compression routines of the IJG JPEG library configured for 16 bits/sample. More...

Inheritance diagram for DJCompressIJG16Bit:

## Public Member Functions
| DJCompressIJG16Bit (const DJCodecParameter &cp, EJ_Mode mode, int prediction, int ptrans)
| constructor for lossless JPEG
virtual | ~DJCompressIJG16Bit ()
| destructor
virtual OFCondition | encode (Uint16 columns, Uint16 rows, EP_Interpretation interpr, Uint16 samplesPerPixel, Uint16 *image_buffer, Uint8 *&to, Uint32 &length)
| single frame compression routine for 16-bit raw pixel data.
virtual OFCondition | encode (Uint16 columns, Uint16 rows, EP_Interpretation interpr, Uint16 samplesPerPixel, Uint8 *image_buffer, Uint8 *&to, Uint32 &length)
| single frame compression routine for 8-bit raw pixel data.
virtual Uint16 | bytesPerSample () const
| returns the number of bytes per sample that will be expected when encoding.
virtual Uint16 | bitsPerSample () const
| returns the number of bits per sample that will be expected when encoding.
void | initDestination (dcmtk_jpeg16_compress_struct *cinfo)
| callback for IJG compress destination manager.
int | emptyOutputBuffer (dcmtk_jpeg16_compress_struct *cinfo)
| callback for IJG compress destination manager.
void | termDestination (dcmtk_jpeg16_compress_struct *cinfo)
| callback for IJG compress destination manager.
virtual void | emitMessage (void *arg, int msg_level) const
| callback function used to report warning messages and the like.
Public Member Functions inherited from DJEncoder
| DJEncoder ()
| default constructor
virtual | ~DJEncoder ()
| destructor

## Private Member Functions
| DJCompressIJG16Bit (const DJCompressIJG16Bit &)
| private undefined copy constructor
DJCompressIJG16Bit & | operator= (const DJCompressIJG16Bit &)
| private undefined copy assignment operator
void | cleanup ()
| cleans up pixelDataList, called from destructor and error handlers

## Private Attributes
const DJCodecParameter * | cparam
| codec parameters
int | psv
| for lossless compression, defines selection value
int | pt
| for lossless compression, defines point transform
EJ_Mode | modeofOperation
| enum for mode of operation (baseline, sequential, progressive etc.)
OFList< unsigned char * > | pixelDataList
| list of compressed pixel data blocks
size_t | bytesInLastBlock
| filled number of bytes in last block in pixelDataList

## Detailed Description

this class encapsulates the compression routines of the IJG JPEG library configured for 16 bits/sample.

## Constructor & Destructor Documentation

## ◆ DJCompressIJG16Bit()

DJCompressIJG16Bit::DJCompressIJG16Bit | ( | const DJCodecParameter & | cp,
|  | EJ_Mode | mode,
|  | int | prediction,
|  | int | ptrans )

constructor for lossless JPEG

Parameters

  cp | codec parameters
  prediction | predictor
  ptrans | point transform

Referenced by DJCompressIJG16Bit(), and operator=().

## Member Function Documentation

## ◆ emitMessage()

virtual void DJCompressIJG16Bit::emitMessage | ( | void * | arg,
|  | int | msg_level ) const
| virtual

callback function used to report warning messages and the like.

Should not be called by user code directly.

Parameters

  arg | opaque pointer to JPEG compress structure
  msg_level | -1 for warnings, 0 and above for trace messages

## ◆ emptyOutputBuffer()

int DJCompressIJG16Bit::emptyOutputBuffer | ( | dcmtk_jpeg16_compress_struct * | cinfo | ) |

callback for IJG compress destination manager.

Internal use only, not to be called by client code.

Parameters

  cinfo | pointer to compress info

## ◆ encode() [1/2]

virtual OFCondition DJCompressIJG16Bit::encode | ( | Uint16 | columns,
|  | Uint16 | rows,
|  | EP_Interpretation | interpr,
|  | Uint16 | samplesPerPixel,
|  | Uint16 * | image_buffer,
|  | Uint8 *& | to,
|  | Uint32 & | length )
| virtual

single frame compression routine for 16-bit raw pixel data.

May only be called if bytesPerSample() == 2.

Parameters

  columns | columns of frame
  rows | rows of frame
  interpr | photometric interpretation of input frame
  samplesPerPixel | samples per pixel of input frame
  image_buffer | pointer to frame buffer
  to | compressed frame returned in this parameter upon success
  length | length of compressed frame (in bytes) returned in this parameter upon success; length guaranteed to be always even.

Returns
  EC_Normal if successful, an error code otherwise.

Implements DJEncoder.

## ◆ encode() [2/2]

virtual OFCondition DJCompressIJG16Bit::encode | ( | Uint16 | columns,
|  | Uint16 | rows,
|  | EP_Interpretation | interpr,
|  | Uint16 | samplesPerPixel,
|  | Uint8 * | image_buffer,
|  | Uint8 *& | to,
|  | Uint32 & | length )
| virtual

single frame compression routine for 8-bit raw pixel data.

May only be called if bytesPerSample() == 1.

Parameters

  columns | columns of frame
  rows | rows of frame
  interpr | photometric interpretation of input frame
  samplesPerPixel | samples per pixel of input frame
  image_buffer | pointer to frame buffer
  to | compressed frame returned in this parameter upon success
  length | length of compressed frame (in bytes) returned in this parameter upon success; length guaranteed to be always even.

Returns
  EC_Normal if successful, an error code otherwise.

Implements DJEncoder.

## ◆ initDestination()

void DJCompressIJG16Bit::initDestination | ( | dcmtk_jpeg16_compress_struct * | cinfo | ) |

callback for IJG compress destination manager.

Internal use only, not to be called by client code.

Parameters

  cinfo | pointer to compress info

## ◆ termDestination()

void DJCompressIJG16Bit::termDestination | ( | dcmtk_jpeg16_compress_struct * | cinfo | ) |

callback for IJG compress destination manager.

Internal use only, not to be called by client code.

Parameters

  cinfo | pointer to compress info

The documentation for this class was generated from the following file:

- dcmjpeg/include/dcmtk/dcmjpeg/djeijg16.h

Generated on Sat Mar 1 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2